
-- all things slash-command related

-- cross-module access
local	KarmaObj = KarmaAvEnK;

local	CommandQueueLockSource = nil;
local	CommandQueueLockAt = 0;
local	CommandQueueLockMsgDelta = 20;

function	KarmaObj.Slash.CommandQLock(sFrom)
	if (CommandQueueLockSource == nil) then
		CommandQueueLockAt = GetTime();
		CommandQueueLockSource = sFrom;
		return true, CommandQueueLockSource;
	else
		local	iDelta = GetTime() - CommandQueueLockAt;
		local	sDelta = format("%02im %02is", math.floor(iDelta / 60), iDelta % 60);
		KarmaChatSecondary("CommandQ: Lock request from <" .. sFrom .. "> ignored, already locked to <" .. CommandQueueLockSource .. "> since " .. sDelta);
		return false, CommandQueueLockSource;
	end
end

function	KarmaObj.Slash.CommandQLocked(fTimeNow)
	if (CommandQueueLockSource and fTimeNow) then
		local	iDelta = fTimeNow - CommandQueueLockAt;
		if (iDelta > CommandQueueLockMsgDelta) then
			if (CommandQueueLockMsgDelta < 80) then
				KarmaChatDebug("CommandQ locked via <" .. CommandQueueLockSource .. "> since " .. format("%.1f", iDelta));
			else
				local	sDelta = format("%02im %02is", math.floor(iDelta / 60), iDelta % 60);
				KarmaChatSecondaryFallbackDefault("|cFFFF6080Command processing locked by command <" .. CommandQueueLockSource .. "> since " .. sDelta .. ". This should not happen. :-(|r");
			end

			CommandQueueLockMsgDelta = CommandQueueLockMsgDelta * 2;
		end
	end

	return CommandQueueLockSource, CommandQueueLockAt;
end

function	KarmaObj.Slash.CommandQUnlock(sFrom)
	if (CommandQueueLockSource == sFrom) then
		CommandQueueLockSource = nil;
		CommandQueueLockMsgDelta = 15;
		return true;
	elseif (CommandQueueLockSource) then
		local	iDelta = GetTime() - CommandQueueLockAt;
		local	sDelta = format("%02im %02is", math.floor(iDelta / 60), iDelta % 60);
		KarmaChatSecondary("CommandQ: Unlock request from <" .. sFrom .. "> ignored, still locked to <" .. CommandQueueLockSource .. "> since " .. sDelta);
		return false, CommandQueueLockSource;
	else
		KarmaChatSecondary("CommandQ: Unlock request from <" .. sFrom .. "> ignored, no lock set.");
	end
end

